/*
 * Copyright 2011 Raster Software Vigo
 *
 * This file is part of ttos
 *
 * ttos is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * ttos is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

/*
 * clients.h
 *
 *  Created on: 18/09/2010
 *      Author: raster
 */

#ifndef CLIENTS_H_
#define CLIENTS_H_

#include "global_vars.h"

struct _client_data *clients_new(struct minibus_connection *connection,void *data);
void clients_destroy(void *object);
uint32_t clients_init(uint32_t port, uint32_t answer_port, struct minibus_connection *queue, void *user_data);
void clients_send_resolution(struct minibus_connection *queue);
uint32_t clients_define_windows(uint32_t port, uint32_t answer_port, struct minibus_connection *connection, void *screen_data);
uint32_t clients_set_client_window(uint32_t port, uint32_t answer_port, struct minibus_connection *connection, void *user_data);
uint32_t clients_window_set_visible(uint32_t port, uint32_t answer_port, struct minibus_connection *connection, void *user_data);
uint32_t clients_move_to_fg(uint32_t port, uint32_t answer_port, struct minibus_connection *connection, void *user_data);
bool clients_do_move_to_fg(uint32_t client_uid);

#endif /* CLIENTS_H_ */
