/*
 * Copyright 2011 Raster Software Vigo
 *
 * This file is part of ttos
 *
 * ttos is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * ttos is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

/*
 * global_vars.c
 *
 *  Created on: 16/09/2010
 *      Author: raster
 */

#include "global_vars.h"

struct _window *windows; ///< Array containing the currently defined windows
uint32_t n_windows; ///< Number of defined windows

struct minibus_master *main_queue; ///< Queue of the system
struct minibus_list clients; ///< list with all the clients in the system
struct minibus_list bitmaps; ///< List with all currently loaded bitmaps
struct minibus_list timers; ///< List with all the current timers
struct minibus_list tab_scroll; ///< List with all the current tabs being scrolled
struct minibus_list ipc; ///< List with all the IPC buses currently being used
struct _client_data *window_manager; ///< Pointer to the client who plays the role of window manager
struct minibus_connection *write_conn; ///< Pointer to the scratchpad connection used to send messages to clients

uint32_t touch_window; ///< Window which receives the current touch event
struct _widget *touch_widget; ///< Widget which receives the current touch event

uint32_t touch_counter; ///< Counter of touches made before a final click has been made
bool large_touch_made; ///< True if the user made a "large touch", so the CLICK event must be discarded

struct ttos_uid_c *ttos_uids; ///< Used to obtain the UIDs for tabs, timers and sharemems
struct ttos_uid_c *ttos_ipc_uid; ///< Used to obtain the UIDs for DBus-style IPC

TTOS_Surface *base;
struct tsdev *ts;

struct _font_base *base_font;
