/*
 * Copyright 2010 (C) Raster Software Vigo (Sergio Costas)
 * This file is part of MINIBUS
 *
 * MINIBUS is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * MINIBUS is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

/*
 * minibus_test_listeners.c
 *
 *  Created on: 19/01/2011
 *      Author: raster
 */

#include <unistd.h>
#include <stdio.h>
#include <stdlib.h>
#include <poll.h>

#include "minibus.h"

uint32_t cb_test3(uint32_t port, uint32_t answer_port, struct minibus_connection *conn,void *data);
int the_pipe[2];

uint32_t cb_test(uint32_t port, uint32_t answer_port, struct minibus_connection *connection,void *data) {

	printf("H: Callback al puerto %d\n",port);

	return 0;
}

uint32_t cb_test2(uint32_t port, uint32_t answer_port, struct minibus_connection *connection,void *data) {

	printf("H: Callback 2 al puerto %d\n",port);

	return 0;
}

int32_t cb_test4(struct minibus_master *queue, uint32_t timeout,void *data) {

	struct minibus_connection *conn=data;
	uint32_t counter;

	if (timeout) {
		counter=cb_test3(30,20,conn,queue);
		printf("\n\n");
	} else {
		counter=0;
	}

	if (counter<3) {
		return 1000;
	} else {
		return -1;
	}

}

uint32_t cb_test3(uint32_t port, uint32_t answer_port, struct minibus_connection *conn,void *data) {

	struct minibus_master *queue=data;
	static int counter=0;

	printf("P: Callback 3 al puerto %d\n",port);
	minibus_set_timeout_callback(queue, cb_test4,conn);

	switch(counter) {
	case 0:
		printf("P: Envio un caracter al pipe y espero un segundo\n");
		write(the_pipe[1],"a",1);
	break;
	case 1:
		printf("P: Envio un mensaje al puerto de respuesta %d\n",answer_port);
		minibus_start_message(queue->send_connection,answer_port,0);
		minibus_server_send(queue->send_connection,conn,false);
	break;
	case 2:
		printf("P: Envio otro mensaje al puerto de respuesta %d\n",answer_port);
		minibus_start_message(queue->send_connection,answer_port,0);
		minibus_server_send(queue->send_connection,conn,false);
	break;
	case 3:
		printf("P: Envio un mensaje al puerto 10\n");
		minibus_start_message(queue->send_connection,10,0);
		minibus_server_send(queue->send_connection,conn,false);
	break;
	}
	counter++;
	return (counter);
}

void listener_cb (int fd, short revents,void *data) {

	char tmp;

	printf("H: Callback a listener\n");

	read(the_pipe[0],&tmp,1);

	printf("H: Leido del pipe\n");

}

void child() {

	struct minibus_master *queue;
	struct minibus_connection *conn;

	sleep(1);

	queue=minibus_init("/tmp/test_listener",0);
	printf("Entro en hijo %d\n",queue->id_socket);
	minibus_add_callback(queue,10,cb_test,NULL);
	minibus_add_callback(queue,20,cb_test2,NULL);
	minibus_add_listener(queue,the_pipe[0],POLLIN,listener_cb,NULL);
	conn=minibus_get_first_connection(queue);

	printf("El hijo envia un mensaje al padre\n");

	minibus_start_message(conn,30,20);
	minibus_send(conn);

	printf("El hijo espera un mensaje en el puerto 20 sin ejecutar callbacks ni atender a listeners\n");
	minibus_wait_for_port(conn,20,false);
	printf("Recibido mensaje\n");
	printf("El hijo espera ahora un mensaje en el puerto 10 ejecutando callbacks y atendiendo a listeners\n");
	minibus_wait_for_port(conn,10,true);
	printf("Mensaje recibido\n");
}


void parent() {

	struct minibus_master *queue;

	queue=minibus_init("/tmp/test_listener",1);
	printf("Entro en padre %d\n",queue->id_socket);

	minibus_add_callback(queue,30,cb_test3,queue);
	minibus_run_loop(queue);

}

int main() {

	pipe(the_pipe);

	if (0==fork()) {
		child();
	} else {
		parent();
	}

	return 0;
}

