/*
 * Copyright 2011 Raster Software Vigo
 *
 * This file is part of ttos
 *
 * ttos is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * ttos is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

/*
 * sharemem.h
 *
 *  Created on: 20/02/2011
 *      Author: raster
 */

#ifndef SHAREMEM_H_
#define SHAREMEM_H_

#include <stdint.h>
#include <stdbool.h>
#include <stdio.h>

#include "ttos_lib/ttos_structs.h"
#include "minibus/minibus.h"

struct _shared_mem {

	void *pixels;
	uint16_t width;
	uint16_t height;
	uint32_t uid;
	bool has_alpha;
	size_t final_size;
};

uint32_t sharemem_create(uint32_t port, uint32_t answer_port, struct minibus_connection *connection, void *private_data);
uint32_t sharemem_destroy(uint32_t port, uint32_t answer_port, struct minibus_connection *connection, void *private_data);
struct _shared_mem* shaemem_new(Cstring file, uint16_t width, uint16_t height, bool has_alpha);
void sharemem_free(void *element);

#endif /* SHAREMEM_H_ */
