/*
 * Copyright 2011 Raster Software Vigo
 *
 * This file is part of ttos
 *
 * ttos is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * ttos is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 * ttos_keyboard.c
 *
 *  Created on: 17/03/2011
 *      Author: raster
 */

/** @file */

#include <stdlib.h>
#include <string.h>
#include <stdio.h>

#include "helper_functions.h"
#include "ttos_keyboard.h"


struct _ttos_key_buttons ttos_letter_lower[]={
	{TTOS_NO_STOCK_BUTTON,"a" ,NULL,true,TTOS_RESERVED_PORTS+1,0,0},
	{TTOS_NO_STOCK_BUTTON,"b" ,NULL,true,TTOS_RESERVED_PORTS+1,0,0},
	{TTOS_NO_STOCK_BUTTON,"c" ,NULL,true,TTOS_RESERVED_PORTS+1,0,0},
	{TTOS_NO_STOCK_BUTTON,"d" ,NULL,true,TTOS_RESERVED_PORTS+1,0,0},
	{TTOS_NO_STOCK_BUTTON,"e" ,NULL,true,TTOS_RESERVED_PORTS+1,0,0},
	{TTOS_NO_STOCK_BUTTON,"f" ,NULL,true,TTOS_RESERVED_PORTS+1,0,0},
	{TTOS_NO_STOCK_BUTTON,"g" ,NULL,true,TTOS_RESERVED_PORTS+1,0,0},
	{TTOS_NO_STOCK_BUTTON,"h" ,NULL,true,TTOS_RESERVED_PORTS+1,0,0},

	{TTOS_NO_STOCK_BUTTON,"i" ,NULL,true,TTOS_RESERVED_PORTS+1,0,0},
	{TTOS_NO_STOCK_BUTTON,"j" ,NULL,true,TTOS_RESERVED_PORTS+1,0,0},
	{TTOS_NO_STOCK_BUTTON,"k" ,NULL,true,TTOS_RESERVED_PORTS+1,0,0},
	{TTOS_NO_STOCK_BUTTON,"l" ,NULL,true,TTOS_RESERVED_PORTS+1,0,0},
	{TTOS_NO_STOCK_BUTTON,"m" ,NULL,true,TTOS_RESERVED_PORTS+1,0,0},
	{TTOS_NO_STOCK_BUTTON,"n" ,NULL,true,TTOS_RESERVED_PORTS+1,0,0},
	{TTOS_NO_STOCK_BUTTON,"o" ,NULL,true,TTOS_RESERVED_PORTS+1,0,0},
	{TTOS_NO_STOCK_BUTTON,"p" ,NULL,true,TTOS_RESERVED_PORTS+1,0,0},

	{TTOS_NO_STOCK_BUTTON,"q" ,NULL,true,TTOS_RESERVED_PORTS+1,0,0},
	{TTOS_NO_STOCK_BUTTON,"r" ,NULL,true,TTOS_RESERVED_PORTS+1,0,0},
	{TTOS_NO_STOCK_BUTTON,"s" ,NULL,true,TTOS_RESERVED_PORTS+1,0,0},
	{TTOS_NO_STOCK_BUTTON,"t" ,NULL,true,TTOS_RESERVED_PORTS+1,0,0},
	{TTOS_NO_STOCK_BUTTON,"u" ,NULL,true,TTOS_RESERVED_PORTS+1,0,0},
	{TTOS_NO_STOCK_BUTTON,"v" ,NULL,true,TTOS_RESERVED_PORTS+1,0,0},
	{TTOS_NO_STOCK_BUTTON,"w" ,NULL,true,TTOS_RESERVED_PORTS+1,0,0},
	{TTOS_NO_STOCK_BUTTON,"x" ,NULL,true,TTOS_RESERVED_PORTS+1,0,0},

	{TTOS_NO_STOCK_BUTTON,"y" ,NULL,true,TTOS_RESERVED_PORTS+1,0,0},
	{TTOS_NO_STOCK_BUTTON,"z" ,NULL,true,TTOS_RESERVED_PORTS+1,0,0},
	{TTOS_NO_STOCK_BUTTON,"." ,NULL,true,TTOS_RESERVED_PORTS+1,0,0},
	{TTOS_NO_STOCK_BUTTON,"," ,NULL,true,TTOS_RESERVED_PORTS+1,0,0},
	{TTOS_NO_STOCK_BUTTON," " ,NULL,true,TTOS_RESERVED_PORTS+1,0,1},
	{TTOS_NO_STOCK_BUTTON,NULL ,NULL,false,TTOS_RESERVED_PORTS+1,0,0}, // NULL button because the previous one is double-width
	{TTOS_LEFT_BUTTON    ,NULL ,NULL,false,TTOS_RESERVED_PORTS+1,0,0},
	{TTOS_NO_STOCK_BUTTON,"1A/",NULL,true,TTOS_RESERVED_PORTS+1,4,0}
};

struct _ttos_key_buttons ttos_letter_upper[]={
	{TTOS_NO_STOCK_BUTTON,"A" ,NULL,true,TTOS_RESERVED_PORTS+1,0,0},
	{TTOS_NO_STOCK_BUTTON,"B" ,NULL,true,TTOS_RESERVED_PORTS+1,0,0},
	{TTOS_NO_STOCK_BUTTON,"C" ,NULL,true,TTOS_RESERVED_PORTS+1,0,0},
	{TTOS_NO_STOCK_BUTTON,"D" ,NULL,true,TTOS_RESERVED_PORTS+1,0,0},
	{TTOS_NO_STOCK_BUTTON,"E" ,NULL,true,TTOS_RESERVED_PORTS+1,0,0},
	{TTOS_NO_STOCK_BUTTON,"F" ,NULL,true,TTOS_RESERVED_PORTS+1,0,0},
	{TTOS_NO_STOCK_BUTTON,"G" ,NULL,true,TTOS_RESERVED_PORTS+1,0,0},
	{TTOS_NO_STOCK_BUTTON,"H" ,NULL,true,TTOS_RESERVED_PORTS+1,0,0},

	{TTOS_NO_STOCK_BUTTON,"I" ,NULL,true,TTOS_RESERVED_PORTS+1,0,0},
	{TTOS_NO_STOCK_BUTTON,"J" ,NULL,true,TTOS_RESERVED_PORTS+1,0,0},
	{TTOS_NO_STOCK_BUTTON,"K" ,NULL,true,TTOS_RESERVED_PORTS+1,0,0},
	{TTOS_NO_STOCK_BUTTON,"L" ,NULL,true,TTOS_RESERVED_PORTS+1,0,0},
	{TTOS_NO_STOCK_BUTTON,"M" ,NULL,true,TTOS_RESERVED_PORTS+1,0,0},
	{TTOS_NO_STOCK_BUTTON,"N" ,NULL,true,TTOS_RESERVED_PORTS+1,0,0},
	{TTOS_NO_STOCK_BUTTON,"O" ,NULL,true,TTOS_RESERVED_PORTS+1,0,0},
	{TTOS_NO_STOCK_BUTTON,"P" ,NULL,true,TTOS_RESERVED_PORTS+1,0,0},

	{TTOS_NO_STOCK_BUTTON,"Q" ,NULL,true,TTOS_RESERVED_PORTS+1,0,0},
	{TTOS_NO_STOCK_BUTTON,"R" ,NULL,true,TTOS_RESERVED_PORTS+1,0,0},
	{TTOS_NO_STOCK_BUTTON,"S" ,NULL,true,TTOS_RESERVED_PORTS+1,0,0},
	{TTOS_NO_STOCK_BUTTON,"T" ,NULL,true,TTOS_RESERVED_PORTS+1,0,0},
	{TTOS_NO_STOCK_BUTTON,"U" ,NULL,true,TTOS_RESERVED_PORTS+1,0,0},
	{TTOS_NO_STOCK_BUTTON,"V" ,NULL,true,TTOS_RESERVED_PORTS+1,0,0},
	{TTOS_NO_STOCK_BUTTON,"W" ,NULL,true,TTOS_RESERVED_PORTS+1,0,0},
	{TTOS_NO_STOCK_BUTTON,"X" ,NULL,true,TTOS_RESERVED_PORTS+1,0,0},

	{TTOS_NO_STOCK_BUTTON,"Y" ,NULL,true,TTOS_RESERVED_PORTS+1,0,0},
	{TTOS_NO_STOCK_BUTTON,"Z" ,NULL,true,TTOS_RESERVED_PORTS+1,0,0},
	{TTOS_NO_STOCK_BUTTON,";" ,NULL,true,TTOS_RESERVED_PORTS+1,0,0},
	{TTOS_NO_STOCK_BUTTON,":" ,NULL,true,TTOS_RESERVED_PORTS+1,0,0},
	{TTOS_NO_STOCK_BUTTON," " ,NULL,true,TTOS_RESERVED_PORTS+1,0,1},
	{TTOS_NO_STOCK_BUTTON,NULL,NULL,false,TTOS_RESERVED_PORTS+1,0,0}, // NULL button because the previous one is double-width
	{TTOS_LEFT_BUTTON    ,NULL,NULL,false,TTOS_RESERVED_PORTS+1,0,0},
	{TTOS_NO_STOCK_BUTTON,"1A/",NULL,true,TTOS_RESERVED_PORTS+1,4,0}
};

struct _ttos_key_buttons ttos_symbols[]={
	{TTOS_NO_STOCK_BUTTON,"1" ,NULL,true,TTOS_RESERVED_PORTS+1,0,0},
	{TTOS_NO_STOCK_BUTTON,"2" ,NULL,true,TTOS_RESERVED_PORTS+1,0,0},
	{TTOS_NO_STOCK_BUTTON,"3" ,NULL,true,TTOS_RESERVED_PORTS+1,0,0},
	{TTOS_NO_STOCK_BUTTON,"4" ,NULL,true,TTOS_RESERVED_PORTS+1,0,0},
	{TTOS_NO_STOCK_BUTTON,"5" ,NULL,true,TTOS_RESERVED_PORTS+1,0,0},
	{TTOS_NO_STOCK_BUTTON,"6" ,NULL,true,TTOS_RESERVED_PORTS+1,0,0},
	{TTOS_NO_STOCK_BUTTON,"7" ,NULL,true,TTOS_RESERVED_PORTS+1,0,0},
	{TTOS_NO_STOCK_BUTTON,"8" ,NULL,true,TTOS_RESERVED_PORTS+1,0,0},

	{TTOS_NO_STOCK_BUTTON,"9" ,NULL,true,TTOS_RESERVED_PORTS+1,0,0},
	{TTOS_NO_STOCK_BUTTON,"0" ,NULL,true,TTOS_RESERVED_PORTS+1,0,0},
	{TTOS_NO_STOCK_BUTTON,"!",NULL,true,TTOS_RESERVED_PORTS+1,0,0},
	{TTOS_NO_STOCK_BUTTON,"\"",NULL,true,TTOS_RESERVED_PORTS+1,0,0},
	{TTOS_NO_STOCK_BUTTON,"@" ,NULL,true,TTOS_RESERVED_PORTS+1,0,0},
	{TTOS_NO_STOCK_BUTTON,"|" ,NULL,true,TTOS_RESERVED_PORTS+1,0,0},
	{TTOS_NO_STOCK_BUTTON,"/" ,NULL,true,TTOS_RESERVED_PORTS+1,0,0},
	{TTOS_NO_STOCK_BUTTON,"\\",NULL,true,TTOS_RESERVED_PORTS+1,0,0},

	{TTOS_NO_STOCK_BUTTON,"+" ,NULL,true,TTOS_RESERVED_PORTS+1,0,0},
	{TTOS_NO_STOCK_BUTTON,"-" ,NULL,true,TTOS_RESERVED_PORTS+1,0,0},
	{TTOS_NO_STOCK_BUTTON,"*" ,NULL,true,TTOS_RESERVED_PORTS+1,0,0},
	{TTOS_NO_STOCK_BUTTON,"?" ,NULL,true,TTOS_RESERVED_PORTS+1,0,0},
	{TTOS_NO_STOCK_BUTTON,"<" ,NULL,true,TTOS_RESERVED_PORTS+1,0,0},
	{TTOS_NO_STOCK_BUTTON,">" ,NULL,true,TTOS_RESERVED_PORTS+1,0,0},
	{TTOS_NO_STOCK_BUTTON,"_" ,NULL,true,TTOS_RESERVED_PORTS+1,0,0},
	{TTOS_NO_STOCK_BUTTON,"=" ,NULL,true,TTOS_RESERVED_PORTS+1,0,0},

	{TTOS_NO_STOCK_BUTTON,"(" ,NULL,true,TTOS_RESERVED_PORTS+1,0,0},
	{TTOS_NO_STOCK_BUTTON,")" ,NULL,true,TTOS_RESERVED_PORTS+1,0,0},
	{TTOS_NO_STOCK_BUTTON,"." ,NULL,true,TTOS_RESERVED_PORTS+1,0,0},
	{TTOS_NO_STOCK_BUTTON,"$" ,NULL,true,TTOS_RESERVED_PORTS+1,0,0},
	{TTOS_NO_STOCK_BUTTON,"&" ,NULL,true,TTOS_RESERVED_PORTS+1,0,0},
	{TTOS_NO_STOCK_BUTTON," " ,NULL,true,TTOS_RESERVED_PORTS+1,0,0},
	{TTOS_LEFT_BUTTON    ,NULL,NULL,false,TTOS_RESERVED_PORTS+1,0,0},
	{TTOS_NO_STOCK_BUTTON,"1A/",NULL,true,TTOS_RESERVED_PORTS+1,4,0}
};

struct ttos_keyboard_data *ttos_new_keyboard(struct ttos_object *master, uint8_t type, Cstring text, bool scroll) {

	struct _ttos_key_buttons *keyboard;
	struct ttos_keyboard_data *data;
	struct ttos_keyboard s_keyb;
	struct ttos_color color[]={
			{0xFF,0xFF,0xFF,0xFF}, // keys color
			{0xEF,0xEF,0xEF,0xFF}, // bg color
			{0xBF,0xBF,0xBF,0xFF}, // screen color
			{0x00,0x00,0x00,0xFF}, // text color
			{0xA4,0xDF,0x45,0xFF}  // special keys color
	};

	uint32_t margin,y,rv,width;
	uint8_t swap_mode;

	data=malloc(sizeof(struct ttos_keyboard_data));
	if (!data) {
		return NULL;
	}

	margin=2;
	y=50;
	width=(master->width-(8*margin))/8;

	data->tab=ttos_new_tab(master,TTOS_SYNC_ANSWER);
	ttos_set_tab_bg(master,TTOS_SYNC_ANSWER,data->tab,color+1);
	ttos_new_color_area(master,TTOS_SYNC_ANSWER,data->tab,2*margin+width,margin,master->width-2*width-4*margin,y-2*margin,color+2,0,0);

	data->intro=ttos_new_button(master,TTOS_SYNC_ANSWER,data->tab,master->width-width-margin,margin,width,y-2*margin,TTOS_INTRO_BUTTON,NULL,"",color,NULL,TTOS_WIDGET_FONT_HALIGN_CENTER|TTOS_WIDGET_FONT_VALIGN_MIDDLE|TTOS_WIDGET_BUTTON_NO_TEXT,TTOS_RESERVED_PORTS+1);
	data->cancel=ttos_new_button(master,TTOS_SYNC_ANSWER,data->tab,margin,margin,width,y-2*margin,TTOS_CANCEL_BUTTON,NULL,"",color,NULL,TTOS_WIDGET_FONT_HALIGN_CENTER|TTOS_WIDGET_FONT_VALIGN_MIDDLE|TTOS_WIDGET_BUTTON_NO_TEXT,TTOS_RESERVED_PORTS+1);

	data->text=ttos_new_label(master,TTOS_SYNC_ANSWER,data->tab,3*margin+width,2*margin,master->width-2*width-6*margin,y-4*margin,text,color+3,TTOS_WIDGET_FONT_HALIGN_LEFT|TTOS_WIDGET_FONT_VALIGN_MIDDLE|TTOS_WIDGET_FONT_BIG_LABEL_ALIGN_RIGHT,0);
	type%=3;

	switch(type) {
	case 0:
		keyboard=ttos_letter_lower;
	break;
	case 1:
		keyboard=ttos_letter_upper;
	break;
	case 2:
		keyboard=ttos_symbols;
	break;
	}

	data->keyboard=keyboard;
	s_keyb.buttons=keyboard;
	s_keyb.colors=color;
	s_keyb.width=8;
	s_keyb.height=4;
	data->key_uids=ttos_paint_keyboard(master,data->tab,margin,y,master->width-2*margin,master->height-y-margin,margin,margin,&s_keyb,true);
	if (!data->key_uids) {
		ttos_destroy_tab(master,TTOS_SYNC_ANSWER,data->tab,0);
		free(data);
		return (NULL);
	}

	swap_mode = scroll ? TTOS_TAB_SWAP_MODE_SCROLL_UP : TTOS_TAB_SWAP_MODE_REPLACE;

	rv=ttos_set_visible_tab(master,TTOS_SYNC_ANSWER,data->tab,swap_mode,TTOS_RESERVED_PORTS+2);

	if ((TTOS_ERROR_NO_ERROR==rv)||(TTOS_ERROR_DESTROY_DELAYED==rv)) {
		minibus_wait_for_port(master->conn,TTOS_RESERVED_PORTS+2,false);
	} else {
		ttos_print_error(rv,true);
	}
	ttos_repaint_screen(master,TTOS_SYNC_ANSWER);
	ttos_destroy_tab(master,TTOS_SYNC_ANSWER,data->tab,TTOS_TAB_DELAY_DESTROY);
	return (data);
}


/**
 * Shows a keyboard in a new tab and allows the user to type a string.
 *
 * @param master The connection to the compositor
 * @param o_text The text to show in the edit line
 *
 * @return A pointer to the typed string (which must be freed by the caller) or NULL if the user cancelled
 */

Cstring ttos_keyboard_intro(struct ttos_object *master, Cstring o_text) {

	struct ttos_keyboard_data *kbd;
	struct minibus_data_element *data;
	bool first;
	uint8_t type;
	Dstring text;
	Cstring value;
	bool repaint;
	int32_t error;
	uint32_t uid,loop,*pointer;
	struct _ttos_key_buttons *button;

	type=0;
	text=minibus_new_dstring(o_text);
	first=true;
	repaint=true;

	while(1) {
		minibus_append_dstring(text,"|");
		if (repaint) {
			kbd=ttos_new_keyboard(master,type,text->text,first);
			first=false;
			repaint=false;
		} else {
			ttos_set_label_text(master,TTOS_SYNC_ANSWER,kbd->text,text->text,TTOS_WIDGET_FONT_HALIGN_LEFT|TTOS_WIDGET_FONT_VALIGN_MIDDLE|TTOS_WIDGET_FONT_BIG_LABEL_ALIGN_RIGHT);
		}
		ttos_repaint_screen(master,TTOS_SYNC_ANSWER);
		while(1) {
			minibus_wait_for_port(master->conn,TTOS_RESERVED_PORTS+1,false);
			if (master->conn->master_queue->forced_exit) { // if a forced exit has been received, just cancel
				button=NULL;
				uid=kbd->cancel;
				break;
			}
			data=minibus_read_params(master->conn,"llblllll",&error);
			if (!data) {
				continue;
			}
			uid=data[3].value32;
			free(data);
			pointer=kbd->key_uids;
			button=NULL;
			if ((uid==kbd->cancel)||(uid==kbd->intro)) {
				break;
			}
			for(loop=0;loop<40;loop++) {
				if (*pointer==uid) {
					button=kbd->keyboard+loop;
					break;
				}
				pointer++;
			}
			if (button) {
				break;
			}
		}
		minibus_cut_dstring(text,1); // remove the cursor
		if (!button) {
			if (uid==kbd->cancel) { // cancel button pressed
				minibus_destroy_dstring(text,true);
				return (NULL);
			}
			if (uid==kbd->intro) { // Return button pressed
				value=text->text;
				minibus_destroy_dstring(text,false);
				return (value);
			}
		}
		if (button->stock_button==TTOS_LEFT_BUTTON) {
			minibus_cut_dstring(text,1);
			continue;
		}
		if (!button->string) {
			continue;
		}
		if (!strcmp(button->string,"1A/")) {
			repaint=true;
			type++;
			type%=3;
			continue;
		}
		minibus_append_dstring(text,button->string);
	}
}


int32_t ttos_create_digits(struct ttos_object *master, Cstring text, uint32_t size, int32_t value, uint32_t min, uint32_t max, enum ttos_stock_button next_button) {

	uint32_t newtab;
	uint32_t plus[4];
	uint32_t minus[4];
	uint32_t cancel_button;
	uint32_t ok_button;
	uint32_t loop;
	int32_t error;
	uint32_t x,y,multiplier,rv;
	int32_t v2,v3;
	uint32_t uid;
	char path[15];
	struct ttos_color color;
	struct minibus_data_element *data;
	bool scroll;

	if ((size>4)||(size<1)) {
		return -1;
	}

	if (value>=0x10000) {
		value-=0x10000;
		scroll=false;
	} else {
		scroll=true;
	}

	color.r=color.g=color.b=color.a=0xFF;

	newtab=ttos_new_tab(master,TTOS_SYNC_ANSWER);
	ttos_set_tab_bg(master,TTOS_SYNC_ANSWER,newtab,&color);

	color.r=color.g=color.b=0x00;
	color.a=0xFF;
	ttos_new_label(master,TTOS_SYNC_ANSWER,newtab,38,2,master->width-76,32,text,&color,TTOS_WIDGET_FONT_HALIGN_CENTER|TTOS_WIDGET_FONT_VALIGN_MIDDLE,TTOS_NO_ANSWER);
	cancel_button=ttos_new_button(master,TTOS_SYNC_ANSWER,newtab,2,2,34,34,TTOS_CANCEL_BUTTON,NULL,NULL,NULL,NULL,TTOS_WIDGET_BUTTON_NO_TEXT|TTOS_WIDGET_FONT_ALIGN_CENTER,TTOS_RESERVED_PORTS+2);
	ok_button=ttos_new_button(master,TTOS_SYNC_ANSWER,newtab,master->width-36,2,34,34,next_button,NULL,NULL,NULL,NULL,TTOS_WIDGET_BUTTON_NO_TEXT|TTOS_WIDGET_FONT_ALIGN_CENTER,TTOS_RESERVED_PORTS+2);

	for(loop=0;loop<4;loop++) {
		plus [loop]=0;
		minus[loop]=0;
	}

	y=102;
	x=(master->width-70*size)/2;
	x+=70*(size-1);
	multiplier=1;
	for(loop=0;loop<size;loop++) {
		v2=(value/multiplier)%10;
		sprintf(path,"%d.tga",v2);
		ttos_new_picture(master,TTOS_SYNC_ANSWER,newtab,x,y,path,0,0);
		plus [loop]=ttos_new_button(master,TTOS_SYNC_ANSWER,newtab,x+17,y-36,34,34,TTOS_UP_BUTTON,NULL,NULL,NULL,NULL,TTOS_WIDGET_BUTTON_NO_TEXT|TTOS_WIDGET_FONT_ALIGN_CENTER,TTOS_RESERVED_PORTS+2);
		minus[loop]=ttos_new_button(master,TTOS_SYNC_ANSWER,newtab,x+17,y+102,34,34,TTOS_DOWN_BUTTON,NULL,NULL,NULL,NULL,TTOS_WIDGET_BUTTON_NO_TEXT|TTOS_WIDGET_FONT_ALIGN_CENTER,TTOS_RESERVED_PORTS+2);
		multiplier*=10;
		x-=70;
	}

	rv=ttos_set_visible_tab(master,TTOS_SYNC_ANSWER,newtab,scroll ? TTOS_TAB_SWAP_MODE_SCROLL_LEFT : TTOS_TAB_SWAP_MODE_REPLACE, TTOS_RESERVED_PORTS+3);
	if ((TTOS_ERROR_NO_ERROR==rv)||(TTOS_ERROR_DESTROY_DELAYED==rv)) {
		minibus_wait_for_port(master->conn,TTOS_RESERVED_PORTS+3,false);
	} else {
		ttos_print_error(rv,true);
	}

	ttos_repaint_screen(master,TTOS_SYNC_ANSWER);
	ttos_destroy_tab(master,TTOS_SYNC_ANSWER,newtab,TTOS_TAB_DELAY_DESTROY);

	while(1) {
		minibus_wait_for_port(master->conn,TTOS_RESERVED_PORTS+2,false);
		if (master->conn->master_queue->forced_exit) {
			return -1;
		}
		data=minibus_read_params(master->conn,"llblllll",&error);
		if (!data) {
			continue;
		}
		uid=data[3].value32;
		free(data);
		if (uid==cancel_button) {
			return -1;
		}
		if (uid==ok_button) {
			return (value);
		}
		multiplier=1;
		for(loop=0;loop<size;loop++) {
			v3=value%(multiplier*10);
			v2=value-v3;
			if (uid==plus[loop]) {
				v3+=multiplier;
				v3%=(multiplier*10);
				value=v2+v3;
				if (value>max) {
					value=max;
				}
				return (0x10000+value);
			}
			if (uid==minus[loop]) {
				v3-=multiplier;
				if (v3<0) {
					v3+=(multiplier*10);
				}
				value=v2+v3;
				if (value<min) {
					value=min;
				}
				return (0x10000+value);
			}
			multiplier*=10;
		}
	}

	return -1;
}

/**
 * Asks for a number between MIN and MAX, with original value VALUE and SIZE ciphers (up to 4, so the number can be between
 * 0 and 9999).
 *
 * @param master The connection to the compositor
 * @param text A text to print at the top of the screen
 * @param size The number of digits to use (1 to 4)
 * @param value The initial value
 * @param min The minimum value allowed
 * @param max The maximum value allowed
 * @param next_button The button to use as "ACCEPT"; will be put at the upper right corner
 *
 * @return If the user cancels, it returns -1; if the user accepts, returns the value.
 */


int32_t ttos_ask_for_digit(struct ttos_object *master,Cstring text, uint32_t size, int32_t value, uint32_t min, uint32_t max, enum ttos_stock_button next_button) {

	int32_t retval;

	if (value>max) {
		retval=max;
	} else if (value<min) {
		retval=min;
	} else {
		retval=value;
	}

	while(1) {
		retval=ttos_create_digits(master,text,size,retval,min,max,next_button);
		if (retval<0x10000) {
			return (retval);
		}
	}
}

